package multiselectwrapper;

import main.java.com.thomashaertel.widget.MultiSpinner;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.drawable.Drawable;
import android.util.DisplayMetrics;
import android.view.ViewGroup;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.Pixel;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.keywords.Common.DesignerCustomView;
import anywheresoftware.b4a.objects.LabelWrapper;
import anywheresoftware.b4a.objects.PanelWrapper;
import anywheresoftware.b4a.objects.ViewWrapper;
import anywheresoftware.b4a.objects.TextViewWrapper;
import anywheresoftware.b4a.BA.Events;
import android.view.MotionEvent;

import android.view.View;
import android.view.View.OnClickListener;
import android.view.View.OnLongClickListener;
import android.view.View.OnTouchListener;
import android.view.ViewParent;

import android.graphics.BitmapShader;
import android.graphics.Shader;
import android.graphics.drawable.ShapeDrawable;
import android.graphics.drawable.shapes.RectShape;

import android.app.Activity;
import android.graphics.Color;
import android.os.Bundle;

import android.widget.ArrayAdapter;

import android.widget.Toast;



import java.util.ArrayList;
import java.util.List;



@Author("Johan Schoeman")
@Version(1.00f)
@ShortName("MultiSpinner")
public class multiSelectWrapper extends TextViewWrapper<MultiSpinner> implements DesignerCustomView {


	private BA ba;
	private String eventName;
        private MultiSpinner cv;
        private ArrayAdapter<String> adapter;
        private String[] spinnerdata = null;
        private boolean toastmessage = true;


	
	public void Initialize(BA ba, String EventName) {
		_initialize(ba, null, EventName);
	}

	@Hide
	public void _initialize(BA ba, Object activityClass, String EventName) {
		this.eventName = EventName.toLowerCase(BA.cul);
		this.ba = ba;
		cv = new MultiSpinner(ba.context, null);
                this.setObject(cv);
//                setEventName(this.eventName);
                addListener();
 	}


//        @Hide
//        public void setEventName(String en){
//            cv.setEventName(en);
//            cv.invalidate(); 
//       }


    @Hide
    public void addListener(){
        cv.setCallback(new MultiSpinner.Callback() {
            @Override
            public void selected() {

              if (ba.subExists(eventName + "_selected")) {
                ba.raiseEvent2(ba, false, eventName + "_selected", true, new Object[0]);
              }
            }

            @Override
            public void cancelled() {

              if (ba.subExists(eventName + "_cancelled")) {
                ba.raiseEvent2(ba, false, eventName + "_cancelled", true, new Object[0]);
              }
            }
        });
    }


	
	//programmatically add view
        @Hide
	public void AddToParent(ViewGroup Parent, @Pixel int left, @Pixel int top, @Pixel int width, @Pixel int height) {
		Parent.addView(cv, new BALayout.LayoutParams(left, top, width, height));
	}
	
	//this method cannot be hidden.
  
        
	public void DesignerCreateView(PanelWrapper base, LabelWrapper lw, anywheresoftware.b4a.objects.collections.Map props) {
		ViewGroup vg = (ViewGroup) base.getObject().getParent();
		AddToParent(vg, base.getLeft(), base.getTop(), base.getWidth(), base.getHeight());
		base.RemoveView();
		//set text properties
	}



	public void setLeft(int left)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.left = left;
		cv.getParent().requestLayout();
	}

	public int getLeft()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.left;
	}
	public void setTop(int top)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.top = top;
		cv.getParent().requestLayout();
	}
 
	public int getTop()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.top;
	}
	
	public void setWidth(int Width)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.width = Width;
		cv.getParent().requestLayout();
	}

	public int getWidth()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.width;
	}
	
	public void setHeight(int height)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.height = height;
		cv.getParent().requestLayout();
	}

	public int getHeight()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.height;
	}

        public void ShowTheSpinner(){
        // create spinner list elements
//        adapter = new ArrayAdapter<String>(BA.applicationContext, android.R.layout.simple_spinner_item);
          adapter = new ArrayAdapter<String>(BA.applicationContext, android.R.layout.simple_spinner_dropdown_item);
        for (int i = 0; i < spinnerdata.length; i++){
           adapter.add(spinnerdata[i]);
        }

        // get spinner and set adapter
        cv.setAdapter(adapter, false, onSelectedListener);

        // set initial selection
        boolean[] selectedItems = new boolean[adapter.getCount()];
        selectedItems[1] = true; // select second item
//      cv.setSelected(selectedItems);
        }

    private MultiSpinner.MultiSpinnerListener onSelectedListener = new MultiSpinner.MultiSpinnerListener() {

        public void onItemsSelected(boolean[] selected) {
            // Do something here with the selected items

            StringBuilder builder = new StringBuilder();

            for (int i = 0; i < selected.length; i++) {
                if (selected[i]) {
                    builder.append(adapter.getItem(i)).append(" ");
                }
            }

//            if (ba.subExists(eventName + "_selected")) {
//              ba.raiseEvent2(ba, false, eventName + "_selected", true, new Object[0]);
//            }

            if (toastmessage) 
            Toast.makeText(BA.applicationContext, builder.toString(), Toast.LENGTH_SHORT).show();
        }
    };


    public void setSpinnerData(String[] sd){
        spinnerdata = sd;
    }

    public void setSelected(boolean[] selected) {
        cv.setSelected(selected);
    }

    public void setShowToastMessage(boolean stm) {
        toastmessage = stm;
    }

    public boolean[] getSelected() {
        return cv.getSelected();
    }



}
